﻿<?php

# MODxBB - poll - by N!Ce (A.S.) September, 2010
# Version 0.9.4
# Based on fetchpoll by Noxwizard of phpBB
#::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::



global $auth, $user, $db, $MODxBB_jax, $modx;
$get_view = htmlspecialchars($_GET['view'], ENT_QUOTES);

if (!defined('IN_PHPBB') && !$get_view && $MODxBB_jax != true)
{
	exit;
}

// start session management and init data depending on parent
$phpEx = substr(strrchr(__FILE__, '.'), 1);
$prevpollID = '1';

if ($MODxBB_jax == true) {
	$user->session_begin();
	$user->setup('viewtopic');
} elseif ($get_view && !defined('IN_PHPBB')) {
	unset($get_view);
	define('IN_PHPBB', true);
	define('IN_MODxBB', true);

	$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../forum/';
	include($phpbb_root_path . 'common.' . $phpEx);

	$user->session_begin();
	$auth->acl($user->data);
	$user->setup('viewtopic');

	$view_poll_results = '';
	$view_poll_results = request_var('view','');
} else {
	$user->setup('viewtopic');
	$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../forum/';
	$view_poll_results = '';
	$view_poll_results = request_var('view','');
	$nst_results = ($view_poll_results == 'viewpoll') ? true : false;
}



// generate the form key
$now = time();
$ftkeygen = sha1($now . $user->data['user_form_salt'] . 'posting' . '');

// poll forum ID: separate by comma for multi-forums, eg. '3,8,14'
$CFG['poll_forum'] = array(2);

// BBcodes, smilies, etc... for fully displayed posts
$CFG['allow_bbcode'] = true;
$CFG['allow_smilies'] = true;
$CFG['allow_urls'] = true;

// get the forums the user can read from
$can_read_forum = $auth->acl_getf('f_read');
$forums_auth_ary = array();
foreach($can_read_forum as $key => $forum) {
	if ($forum['f_read'] != 0)	{
		$forums_auth_ary[] = $key;
	}
}

// of the desired forums, pull out the authed ones
$authed_polls_ary = array_intersect($CFG['poll_forum'], $forums_auth_ary);
unset($can_read_forum);
unset($forums_auth_ary);

$flags = (($CFG['allow_bbcode']) ? OPTION_FLAG_BBCODE : 0) + (($CFG['allow_smilies']) ? OPTION_FLAG_SMILIES : 0) + (($CFG['allow_urls']) ? OPTION_FLAG_LINKS : 0);


function fetch_poll($forum_id_ary, $flags, &$votes)
{
	global $config, $db, $user;

	$poll = array();

	// get the topic ID
	$sql = 'SELECT t.forum_id, t.topic_id, t.poll_length, t.poll_max_options, t.poll_start, t.poll_title, t.poll_vote_change, t.topic_first_post_id, t.topic_status, f.forum_status
	FROM ' . TOPICS_TABLE . ' t
	INNER JOIN ' . FORUMS_TABLE . " f ON (t.forum_id = f.forum_id)
	WHERE t.poll_title <> ''
	AND t.topic_approved = 1
	AND " . $db->sql_in_set('t.forum_id', $forum_id_ary) . '
	ORDER BY t.topic_time DESC';

	$result = $db->sql_query_limit($sql, 1);
	$row = $db->sql_fetchrowset($result);
	$db->sql_freeresult($result);

	if (!sizeof($row))
	{
		return false;
	}

	$poll['title'] = $row[0]['poll_title'];
	$poll['topic_id'] = $row[0]['topic_id'];
	$poll['forum_id'] = $row[0]['forum_id'];
	$poll['total'] = 0;
	$poll['topic_status'] = $row[0]['topic_status'];
	$poll['forum_status'] = $row[0]['forum_status'];

	$poll['poll_length'] = $row[0]['poll_length'];
	$poll['poll_vote_change'] = $row[0]['poll_vote_change'];
	$poll['poll_start'] = $row[0]['poll_start'];
	$poll['poll_max_options'] = $row[0]['poll_max_options'];

	// get the poll data
	$sql = 'SELECT p.post_id, p.bbcode_bitfield, p.bbcode_uid, o.poll_option_id, o.poll_option_text, o.poll_option_total
	FROM ' . POSTS_TABLE . ' p, ' . POLL_OPTIONS_TABLE . ' o
	WHERE p.topic_id = o.topic_id
	AND p.post_id = ' . intval($row[0]['topic_first_post_id']);

	$result = $db->sql_query($sql);
	$row = $db->sql_fetchrowset($result);
	$db->sql_freeresult($result);

	$poll['bbcode_bitfield'] = $row[0]['bbcode_bitfield'];
	$poll['bbcode_uid'] = $row[0]['bbcode_uid'];
	$poll['title'] = generate_text_for_display($poll['title'], $poll['bbcode_uid'], $poll['bbcode_bitfield'], $flags);

	foreach($row as $entry) {
		$poll[] = generate_text_for_display($entry['poll_option_text'], $poll['bbcode_uid'], $poll['bbcode_bitfield'], $flags);
		$poll['totals'][] = $entry['poll_option_total'];
		$poll['ids'][] = $entry['poll_option_id'];
		$poll['total'] += $entry['poll_option_total'];
	}

	//
	// VOTES (straight from viewtopic.php)
	//
	if ($user->data['is_registered'])	{
		$sql = 'SELECT poll_option_id
		FROM ' . POLL_VOTES_TABLE . '
		WHERE topic_id = ' . $poll['topic_id'] . '
		AND vote_user_id = ' . $user->data['user_id'];
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result)) {
			$votes[] = $row['poll_option_id'];
		}
		$db->sql_freeresult($result);
	}	else {
		// cookie based guest tracking ... optionally add ip check
		if (isset($_COOKIE[$config['cookie_name'] . '_poll_' . $poll['topic_id']])) {
			$votes = explode(',', $_COOKIE[$config['cookie_name'] . '_poll_' . $poll['topic_id']]);
			$votes = array_map('intval', $votes);
		}
	}
	
	// reverse arrays for proper output
	$poll = array_reverse($poll);
	$poll['ids'] = array_reverse($poll['ids']);
	$poll['totals'] = array_reverse($poll['totals']);

	return $poll;
}


// fetch poll(s)
$votes = array();
$fetchpoll = fetch_poll($authed_polls_ary, $flags, $votes);
$poll_option_row = array();

if (!empty($fetchpoll)) {
	$s_can_vote = (((!sizeof($votes) && $auth->acl_get('f_vote', $fetchpoll['forum_id'])) ||
	($auth->acl_get('f_votechg', $fetchpoll['forum_id']) && $fetchpoll['poll_vote_change'])) &&
	(($fetchpoll['poll_length'] != 0 && $fetchpoll['poll_start'] + $fetchpoll['poll_length'] > time()) || $fetchpoll['poll_length'] == 0) &&
	$fetchpoll['topic_status'] != ITEM_LOCKED &&
	$fetchpoll['forum_status'] != ITEM_LOCKED) ? true : false;

	global $poll_cookied;
	if ((!$auth->acl_get('f_votechg', $fetchpoll['forum_id']) || !$fetchpoll['poll_vote_change']) && $poll_cookied) {
		$s_can_vote = false;
	}
	$s_display_results = ($poll_cookied == 1 || !$s_can_vote || ($s_can_vote && sizeof($votes)) || $view_poll_results == 'viewpoll') ? true : false;
	
	$discuss_url = append_sid("{$phpbb_root_path}viewtopic.$phpEx", 'f=' . $fetchpoll['forum_id'] . '&amp;t=' . $fetchpoll['topic_id']);
	$viewtopic_url = append_sid("{$phpbb_root_path}../modxbb/vote.$phpEx", 'f=' . $fetchpoll['forum_id'] . '&amp;t=' . $fetchpoll['topic_id']);
	if ($MODxBB_jax != true) {
		$current_page = $modx->config['site_url'] . 'index.php?id=' . $modx->documentIdentifier;
	} else {
		$current_page = request_var('redirect', ':D');
	}
	$viewtopic_url2 = append_sid("{$phpbb_root_path}../modxbb/vote.$phpEx", 'f=' . $fetchpoll['forum_id'] . '&amp;t=' . $fetchpoll['topic_id'] . '&amp;redirect='. $current_page);
	$viewtopic_urn = stristr($viewtopic_url2, 'f=');

	$l_max_votes      = ($fetchpoll['poll_max_options'] == 1) ? $user->lang['MAX_OPTION_SELECT'] : sprintf($user->lang['MAX_OPTIONS_SELECT'], $fetchpoll['poll_max_options']);
	$s_poll_question   = $fetchpoll['title'];
	$s_poll_action      = $viewtopic_url . '&amp;nst=1&amp;redirect=' . $current_page;
	$total_votes      = $fetchpoll['total'];

	$s_is_multi_choice   = ($fetchpoll['poll_max_options'] > 1) ? true : false;
	$u_view_results      = $modx->config['site_url'] . 'index.php?id=' . $modx->documentIdentifier . '&amp;view=viewpoll';

	for ($i = 0; $i < count($fetchpoll['ids']); $i++) {
		$option_pct = ($fetchpoll['total'] > 0) ? $fetchpoll['totals'][$i] / $fetchpoll['total'] : 0;
		$option_pct_txt = sprintf("%.1d%%", ($option_pct * 100));

		$poll_option_row[$i]['OPTION_ID']      = $fetchpoll['ids'][$i];
		$poll_option_row[$i]['OPTION_PERCENT']   = $option_pct_txt;
		$poll_option_row[$i]['OPTION_TEXT']   = $fetchpoll[$i];

		// cookies are written at the end, thus we do this one manually
		if ($MODxBB_jax == true && !$user->data['is_registered'] && !$poll_message) {
			$poll_option_row[$i]['OPTION_VOTED'] = ($poll_option_row[$i]['OPTION_VOTED'] != true) ? false : true;
			$temp_id = (int) $voted_id[$i];
			if ($temp_id > 0) {
				$temp_id = (int) ($temp_id - 1);
				$poll_option_row[$temp_id]['OPTION_VOTED'] = true;
			}
			ksort($poll_option_row);
		} else {
			$poll_option_row[$i]['OPTION_VOTED']   = (in_array($fetchpoll['ids'][$i], $votes)) ? true : false;
		}
		$poll_option_row[$i]['VOTE_RESULT']   = $fetchpoll['totals'][$i];
	}
} else {
	$s_poll_question = false;
}


// output the result
echo '
<h4>Учавствуйте в нашем опросе</h4>
<form id="pollform" method="post" name="pollform" action="' . $s_poll_action . '">
<h2>';

if ($s_poll_question) {
	echo $s_poll_question;
} else {
	echo 'Нет опросов';
}

echo '
</h2><br />
<table>';

foreach($poll_option_row as $poll_option) {
	echo'<tr class="pollrow">';
	if ($s_can_vote) {
		echo '<td style="padding:0; width:18px;">';
		if ($s_is_multi_choice) {
			echo '<input type="checkbox" class="radio" name="vote_id[]" value="' . $poll_option['OPTION_ID'] . '"';
			if ($poll_option['OPTION_VOTED'])
			{
				echo ' checked="checked"';
			}
			echo ' />';
		} else {
			echo '<input type="radio" class="radio" name="vote_id[]" value="' . $poll_option['OPTION_ID'] . '"';
			if ($poll_option['OPTION_VOTED'])
			{
				echo ' checked="checked"';
			}
			echo ' />';
		}
		echo '</td>';
	}
	$polloptions = ($s_display_results) ? 'polloptions' : 'polloptions0';
	echo '<td class="' . $polloptions . '">' . $poll_option['OPTION_TEXT'] . '</td>';
	if ($s_display_results) {
		$totalcount = (max($fetchpoll['totals']) == 0) ? 1 : max($fetchpoll['totals']);
		echo '<td class="pollshare"><div style="width:' . round(((int) $poll_option['VOTE_RESULT']) / $totalcount * 100) . '%;">' . $poll_option['OPTION_PERCENT'] . '</div></td>';
		if ($poll_option['OPTION_VOTED']) {
			echo '<td class="voted" valign="middle"><b title="' . $user->lang['POLL_VOTED_OPTION'] . '">&lsaquo;</b></td>';
		}
		$pollcount = ($poll_option['OPTION_VOTED']) ? 'pollcount' : 'pollcount0';
		echo '<td class="' . $pollcount . '" align="center">' . $poll_option['VOTE_RESULT'] . '</td>';
	}
	echo '</tr>';
}

if ($MODxBB_jax != true) {
	$poll_message = request_var('pm','');
}
if (!$poll_message) {
	$guest_data = array('user_type' => 2, 'user_id' => 1, 'user_permissions' => ':D');
	$acl_returned = $auth->acl_cache($guest_data);
	$guest_permissions = array();
	$guest_permissions = explode("\n", $guest_data['user_permissions']);
	$guestvoting = ((int) substr(base_convert(substr($guest_permissions[$fetchpoll['forum_id']], 0, 6), 36, 2), 28, 1) == 1) ? '<b style="color:green">разрешено</b>' : '<b style="color:red">запрещено</b>';
	$revotz0r = ($fetchpoll['poll_vote_change']) ? '<b style="color:green">разрешено</b>' : '<b style="color:red">запрещено</b>';
	if ($s_can_vote){
		$poll_message = '<span class="pollmsg">(Голоса гостей: ' . $guestvoting . ' &#124; Переголосование: ' . $revotz0r . ')</span>';
	} else {
		$poll_message = '(Голоса гостей: ' . $guestvoting . ' &#124; Переголосование: ' . $revotz0r . ')';
	}
} else {
	$view_message = 1;
	$poll_message = '<span class="errormsg">' . $poll_message . '</span>';
}

if ($s_can_vote) {
	if ($s_display_results) {
		echo '<tr><td class="maxvotes" align="center" colspan="5">' . $user->lang['TOTAL_VOTES'] . ': <strong>' . $total_votes . '</strong></td></tr>';
	} else {
		echo '<tr><td class="maxvotes" align="center" colspan="5">' . $l_max_votes . '</td></tr>';
	}
	echo '
	<tr><td align="center" colspan="5">' . $poll_message . '
	<span id="submitvote" class="submitvote"><noscript><button class="submitvote" type="submit" name="update">Голосовать</button></noscript>';
	if (($view_poll_results == 'viewpoll' && $nst_results == false) || $MODxBB_jax == true) {
		echo '<button class="submitvote" type="button" onClick="sendRequest();">Голосовать</button>';
	} else {
		echo '
		<script type="text/javascript">
		<!--
		document.getElementById("submitvote").innerHTML = \'<button class="submitvote" type="button" onClick="sendRequest();">Голосовать</button>\';
		//-->
		</script>';
	}
	echo '</span></td></tr>
	<tr><td colspan="5" align="center"><a href="' . $discuss_url . '">Обсудить</a> &nbsp; &bull; &nbsp; ';
} else {
	echo '
	<tr><td class="maxvotes" align="center" colspan="5">' . $user->lang['TOTAL_VOTES'] . ': <strong>' . $total_votes . '</strong></td></tr>
	<tr><td class="pollmsg0" align="center" colspan="4">' . $poll_message . '</td></tr>
	<tr><td colspan="4" align="center"><a href="' . $discuss_url . '">Обсудить</a> &nbsp; &bull; &nbsp; ';
}

if ($s_display_results) {
	echo '
	<a href="' . $modx->config['site_url'] . 'index.php?id=' . $prevpollID . '">Предыдущие опросы</a></td>
	</tr>';
} else {
	echo '
	<span id="viewresults"><noscript><a href="' . $u_view_results . '">' . $user->lang['VIEW_RESULTS'] . '</a></noscript>';
	if ($view_message && ($MODxBB_jax == true)) {
		echo '<a href="javascript:showResults();">Смотреть результаты</a>';
		unset($view_message);
	} else {
		echo '
		<script type="text/javascript">
		<!--
		document.getElementById("viewresults").innerHTML = \'<a href="javascript:showResults();">Смотреть результаты</a>\';
		//-->
		</script>';
	}
	echo '</span></td></tr>';
}

echo '
</table>
<input type="hidden" name="creation_time" value="' . $now . '" />
<input type="hidden" name="form_token" value="' . $ftkeygen . '" />
<input type="hidden" name="urn" value="' . $viewtopic_urn . '" />
</form>';

unset($voted_id, $poll_option_row, $poll_message);

$MODxBB_jax = false;

?>